;;; Ic.el --- Menu system for Emacs
;;
;; Copyright (C) 1997   (Usuda Hiroshi)

;; Author: Usuda Hiroshi <usuda@d4.dion.ne.jp>
;; Keywords: menu
;; Version : 5.3.250
;; Last-Modify : Sun Jul 14 09:02:42 2002
;; Test : GNU Emacs 20.2.2
;; Web : http://www.d4.dion.ne.jp/~usuda/emacs/Ic.el

;;; Commentary:

;;   
;;
;;  This program is free software; you can redistribute it and/or modify
;;  it under the terms of the GNU General Public License as published by
;;  the Free Software Foundation; either version 2 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU General Public License for more details.
;;
;;  You should have received a copy of the GNU General Public License
;;  along with this program; if not, write to the Free Software
;;  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;;
;;  ݻޤʣۡѹ紿ޡѹƤ⤽λ
;;  񤤤ƤϢϤޤۤκݤϡ̵ݾڡ̵Ǥͤ
;;  ޤܤ GNU General Public License version 2פ򸫤
;;  
;;
;;   ǤΤ
;;
;;  ǹܤ֤Ȥν˥塼ǤģϣӤΥե륻
;;  Τ褦ʴǻȤޤܤϴñɲäǤΤǡޥǥ
;;  ˥塼С򥯥åʤͤϡޤȤʤޥɤϿ
;;  ƤǤǤ礦ץץǤ⡢ޤޤ줷
;;  ǽäƤϤǤľǤ⤢٤ϥޥǤޤ
;;  äȣ̣ٶȷ빽ƤޤޤȤ
;;  ʤ衪ӡmisc-Uz.el ɬפǤޤñΤǤư
;;  󡣤ޤǥ饤֥Ǥ Ic 饤֥ȡƤǤ
;;
;;  ʸ˥ץ뤬ޤ
;;
;;  Ver.5 ꡢڹ¤ɽ褦ˤʤޤ
;;
;;   󥹥ȡˡ
;;
;;  Υեѿ load-path ˡϿ줿ǥ쥯ȥˡԡ
;;  ƤɤʤͤϡC-h C-v load-path Ϥȡ
;;  ԡ٤ǥ쥯ȥ꤬ɽޤ˼ºݤ˥˥塼
;;  ե(㤨 : Ic-Um4.el)Ѱդơ~ /.emacs ˰ʲΤ褦
;;  ˡɲäƤ
;;
;;      (load-library "Ic-Um4")
;;
;;  ٤Ȥơեޥ͡ȡǥХåϢΥץ⤪
;;  빽Ǥ
;;
;;  ʤϡΰֺǽˤ褦˼ͳѤ
;;  Ƥƹޤ
;;
;;  ٤ʥץǤϡʸԽϤȤ˺ƵԽȤäƤ
;;  λƵԽȴ뤿ˡ̾ C-x C-s Ϥޤ
;;  ʲѿ~/.emacs ˻ꤹ뤳ȤѹǤޤ
;;
;;  (setq Ic-recursive-key "\C-x\C-s")
;;
;;  ƵԽ򥭥󥻥뤷ȤˤϰʲΥХɤǡ
;;  ޤ(ǤɤȽʤ⤷ޤ͡Ufm  f2 f4 
;;  ɽʸϤ̤ǡ󥻥뤷Ȥޤ)
;;
;;  (setq Ic-recursive-key2 "\C-x\C-k")
;;
;;  ǥեȡХ
;;
;;  Ic-mode-map ˥ХɤƤ
;;
;;      q                       󥻥
;;
;;      RET                     ¹
;;
;;      up      down            岼
;;      C-n     C-p
;;
;;      C-up    C-down          岼(5)
;;
;;      left    right           뺸
;;      C-f     C-b
;;
;;      spase   BS              Ρɰư
;;      C-left  C-right
;;      M-n     M-p
;;
;;      prior   next            ɽ򥹥
;;      S-up    S-down
;;      C-v     M-v
;;
;;      M-left M-right          ̺˰ư
;;
;;      home    end             ɽκǽ(Ǹ)˰ư
;;
;;      C-s C-r                 ɽɥΥ󥯥󥿥륵
;;      M-s M-r
;;
;;      S-right S-left          ǥåɽ
;;      C-M-s   C-M-r
;;
;;      + -                     ɥʬѤ
;;
;;      mouse-1                 쥯
;;      mouse-2                 ܥ쥯(֥륯åǼ¹)
;;
;;      tab                     ʸϿ
;;      M-up M-down             ʸθ
;;
;;   ʤޤǤɤˤȤޤ
;;
;;  ʲ [~/.emacs] ɲäƤߤơ棱򲡤Ƥߤȡ
;;
;;  (require 'Ic)
;;  (define-key global-map [f10] 'sample-func)
;;
;;  ;ñʴؿ
;;  (defun sample-func ()
;;      (interactive)
;;      (let ((func (Ic 'sample-table 'sample-option)))(if func (call-interactively func)))
;;      )
;;
;;  ;option ϡ̾ü쥭ХɤʤɤͿޤ
;;  (setq sample-option '(
;;          (title "ץ")
;;      ))
;;
;;  ;table ϡƹܤ̾ʸ֤ݻꥹȤǤ
;;  (setq sample-table '(
;;      ("ִ"             query-replace                   "ѴʸѴʸϤƤ")
;;      ("ִ ɽ"    query-replace-regexp            )
;;      (" "            search-forward                  )
;;      ("  "         re-search-forward               )
;;      ("  ɽ"   search-forward-regexp           )
;;      (" "            search-backward                 )
;;      ("  "         re-search-backward              )
;;      ("  ɽ"   search-backward-regexp          )
;;      ("   Kill"          kill-rectangle                  "ݥȤȥޡδ֤򡢻ͳѷڤФޤ")
;;      ("   Yank"          yank-rectangle                  "ͳѷΰ򥳥ԡޤ")
;;      ("   쥸"    copy-rectangle-to-register      )
;;      ))
;;
;;  äȤ⡢Ӥˤۺ Um4 ȤäǤ
;;  ӤΤ˺ä褦ʤΤǤ顣
;;
;;  ⤦ҤȤ󤲤Ȥޤ礦ʬڤФ .emacs ɲ
;;  ʤꤷƤߤƤyank ƤߤʤԽΤǡ
;;  ˤäƤͭѤǤ
;;
;; (require 'Ic)
;; (require 'misc-Uz)
;; 
;; (global-set-key [f10] 'Ic-Yank)
;;
;; (defun Ic-Yank ()
;;  (interactive)
;;  (let ((STR (Ic 'Ic-Yank-table 'Ic-Yank-option)))(if STR (insert STR)))
;;  )
;; 
;; (defvar Ic-Yank-table nil)
;; (defvar Ic-Yank-option '(
;;  (title "e:Խ D: l:Ĺ ret:")
;;  (wink 3)(refresh (Ic-yank-refresh))
;;  (keymap Yank-map)
;;  ))
;; (defvar Yank-map (make-keymap))
;; (define-key Yank-map "e" '(lambda () (Ic-redit '(U-mod kill-ring Ic-IDX (buffer-substring (point-min) (point-max))))(Ic-yank-refresh)))
;; (define-key Yank-map Ic-return-key   'Ic-yank-return)
;; (define-key Yank-map "D" '(lambda ()(U-del kill-ring Ic-IDX)(Ic-yank-refresh)))
;; (define-key Yank-map "l" '(lambda ()(setq kill-ring-max (string-to-number (read-from-minibuffer "󥰤Ĺ : " "30")))))
;; 
;; (defun Ic-yank-refresh ()
;;  (setq Ic-Yank-table (mapcar (function(lambda (A)(list nil nil A))) kill-ring))
;;  )
;; 
;; (defun Ic-yank-return (&optional F)
;;  (let ((N(nth Ic-IDX kill-ring)))
;;  (U-del kill-ring Ic-IDX)
;;  (setq kill-ring (append (list N) kill-ring))
;;  (x-set-selection t N)
;;  (setq Ic-return N)
;;  (setq kill-ring-yank-pointer (cons N (nthcdr 1 kill-ring)))
;;  (Ic-quit)
;;  ))
;; 
;;   ̩
;;
;;      ʲʸϤϡʪʣţ̣ץޤΤΥ饤
;;      ֥Ǥ롣äƤΥǤ
;;
;;      ʸ򤤤äͤοͤɤफȽʤɡ⤷Υ饤
;;      ֥ȤäƤߤȤͤ顢θ̵᡼Ǽ䤷
;;      ¿ʬɤǤȽʤ顣
;;
;;  ƤӽФ
;;
;;      (Ic 'table 'option)
;;
;;      table  list ȱĤΥܥˤȤ롣ܺ٤ϼϤ˼
;;      άȡtable ϳƹܤФǡoption
;;      ϥ˥塼ΤФ
;;
;;      Ic ؿ ɥ򣲤ĺ뤬 milk  wine ̾
;;      դ롣milk ˤϡܤɽƤ򥫡֤Ȱʲ
;;      ֤ͤ
;;
;;      (nth 1 (nth Ic-IDX table))
;;
;;      ǡIc-IDX ϥ֤򼨤ǥåǡΥ
;;      ֥ǤϤäȤפѿǤ
;;
;;      wine ɥˤϥΰưȼäƿʾɽ
;;      롣ɽΤϡ(nth 2 (nth Ic-IDX table)) 
;;      ͤǤ롣
;;
;;      ʤߤ (nth 0 (nth Ic-IDX table))ϡܤ̾Ϳ롣
;;
;;      ưϤʴäƿʵǽĤƹԤ
;;      ʬǤ櫓Ƚʤʤä
;;
;;      ȤСmilk ɥʬ䤷ɽǤ⡼(wink
;;      mode)ۺ Ufm ʤɤǻȤ롣
;;
;;      ͭʥХɤ Ic ؿϤȤǡUfm Τ褦˿
;;      ưꤹ뤳ȤǤ롣
;;
;;      Ic ؿ Ic ƤǤ⡢פʤ褦˺äƤ롣
;;      ߥ˥ХåեƤФƤ⡢֤ס
;;
;;  table ϡηͤĥܥ(ƤǤɬפϤʤ)
;;
;;      (("string" return expression next1 next2 user emphasize rest key-select local-keymap open-treep)...)
;;
;;      [0]string
;;
;;              ɽʸ
;;
;;              ʤСֹɽ򤹤롣ȥʤ̤ɽ
;;              롣ꥹȤʤ顢ɾƷ̤ʸľɽ롣
;;
;;      [1]return
;;
;;              ꥿󥭡줿ȤˡIc ؿ֤
;;
;;              ܥ롦ʸ󡦿ͤʤɤ¨¤ Ic ؿ
;;              Ȥ֤뤬ꥹȤξϴؿƤӽФȤɾ
;;              ơnil ꥿󤷤ޤλ֤ͤ
;;              С(Ic-return ***) Τ褦ʸƤӽФ򤹤ɤ
;;               ǤꥹȤ̤ǡ
;;              ɾƥ꥿󤷤ʤ
;;
;;      [2]expression
;;
;;              뤬褿Ȥˤ⤦ĤΥɥ Ic-name-wine
;;              ɽʸ
;;
;;              ʸϤΤޤɽȥѿȤư̤ɽ
;;              ꥹȤʤ顢ɾƷ̤ʸľɽ롣
;;              ǻϤޤꥹȤξ硢ɥƤϾõ줺
;;              ɾ롣Ic wine 쥯Υ
;;              ɥˤʤΤǡͳɤϡ
;;              뤬ư٤˵ưؿȤƻȤäƤ⤤Τ
;;
;;      [3]next1 [4]next2
;;
;;              줾켡ΥΡɤΰꥹȤȥץꥹȡ
;;              ޤϡͤĤĥܥ롣
;;
;;      [5]user
;;
;;              桼ѤǤΰǤСθߴ
;;              ݤĤ˵ǽɲäȤˤϡΥեɤ
;;              ȤäƤʤäïȤΤ
;;
;;      [6]emphasize
;;
;;              ιܤФ롢֤ǤɽˡʲηͿ
;;              롣((line top end face)(0 0 10 face)...)  ϡ
;;              ܤ line ܤ  top  end  face
;;              ɽäƻnil ξˤϡǽιԤ򲫿
;;              ʲ̥ΡɤʤСС
;;
;;      [7]rest
;;
;;              ιܤФ롢̤֤Ǥɽˡʲη
;;              Ϳ롣((line top end face)(0 0 10 face)...)  ϡ
;;              ܤ line ܤ  top  end  face
;;              ɽäƻnil ξˤϡ򤫤ޤ
;;
;;      [8]key-select
;;
;;              硼ȥåʸ
;;
;;      [9]local-keymap
;;
;;              ιܤͭʡ륭ޥåפͿ롣
;;
;;      [10]open-treep
;;
;;              tree ⡼ɤλ˲̤ΥΡɤɽ뤫
;;
;;
;;  option    ϡηͤĥܥ
;;
;;      ((name arg arg ...)...)
;;
;;      name            ץ̾
;;      args            
;;
;;  ץܺ
;;
;;      (title "title strings")
;;
;;          Ƭ˻翧ɽޤΤȤԤݡȤƤ
;;          󡣤ʾȤʸꤹȡɽʤ
;;          ƤޤޤʸǤʤϡɾƷ̤ɽޤ
;;
;;      (milk-width 45)
;;
;;          Ic-name-milk ɥꤷޤIc-wink 
;;          ꤵƤʤȤ˸¤äơwine-width ͥ褷ꤷ
;;          ޤ
;;
;;      (wine-width 54)
;;
;;          Ic-name-wine ɥ 54 ˻ꤷޤ
;;
;;      (wine-split 1 3)
;;
;;          Ic-name-wine ɥ 1 / 3 ˻ꤷޤ
;;
;;      (vertical)
;;
;;          Ic-name-milk  Ic-name-wine ľʬ䤷ޤ
;;
;;      (keymap ...)
;;
;;          ȼγĥХɤ keymap ͿޤǥեȤ
;;          Хɤ˸Τǡ񤭲ǽǤ̥ΡɤǤϡ
;;          ˥Хɤľʤ¤ꡢ̥ΡɤγĥХ
;;          Ѿޤɾ keymap ˤʤѿʣꤹ
;;          ޤ
;;
;;      (no-keymap)
;;
;;          ǥեȤΥޥåפθ¹Ԥޤ󡣥ΡȼΥ
;;          ޥåפȼΥ륭ޥåפƤƤʤ
;;          ȡޤ㤦Τ
;;
;;      (wink 3)                ʬ䤹
;;      (wink (15 27 36 17))    ʬȥɥ(̤)
;;
;;          ʣɽ⡼ɡIc milk ɥĤʬ䤹롣
;;          ǲ˰ưǤޤΡڤؤϡC-left C-right
;;          ǹԤäƤȥܤˤĤ԰ʾȤ褦ʡ
;;          ˥塼ˤϸޤɽ䥫ưѤˤʤޤ
;;
;;      (wink-less 10)
;;
;;          ʣɽ⡼ɡ㣱Ԥݤʬ䤷ޤܥѿꤷɤ
;;
;;      (no-wine)
;;
;;          wine ɥɽޤ
;;
;;      (before-exec    )   Хɤ줿ؿ¹Ԥ
;;      (after-exec     )   Хɤ줿ؿ¹Ԥ
;;      (start          )   ưȤ˼¹
;;      (end            )   Ic λȤɬ¹
;;      (refresh        )   Ρɤڤؤä˼¹(window ʬ夫)
;;
;;          ɥ򤽤Τޤ¸ˤϡʸ¹Ԥɤ
;;          (setq Ic-history (current-window-configuration))
;;
;;      (wine-cut)
;;      (milk-cut)
;;
;;          Ϥ߽ФԤޤ֤ɽʤ褦ˤ
;;
;;      (wine-mode-line ....)
;;      (milk-mode-line ....)
;;
;;          ⡼ɥ饤񼰤ꤹ
;;
;;      (short-cut &rest eval)
;;
;;          Фơܤ򤹤뤫в̤
;;          Ρɤ˰ܤ褦ˤޤϽλ˻ȤΤǶػߡ
;;          table  key-select ιܤСͥ褷ޤeval
;;          ꤷƤФ¹Ԥ̵ХΡɤ߲Ρ
;;          ɤʤФλ¹Ԥ롣
;;
;;      (short-disp)
;;
;;          硼ȥåȤʸ򡢹ܤκǽ˰ޤ
;;
;;      (notcls-win)
;;
;;          軰 nil ξ Ic wine Хåե򥯥ꥢʤ
;;          뤬ưȤɬ Ic wine Хåեϥꥢ롣
;;          ʤΤϡΥץ󤬻ꤵƤȤ(nil
;;          eval) ɽλΤߤǤ롣
;;
;;
;;      (save-node Ic-Table-list)
;;
;;          ˵ưȤ˥Ρɤΰ־Ƹ롣˻ꤵ
;;          Ƥͤϰ־Ϳ뤬ͼΤϽλκݤ Ufm 
;;          ưŪ¸ΤǵˤʤǤ
;;
;;      (tree)
;;
;;          ĥ꡼⡼ɤǤǤ衣Ǥ衣ʤ
;;          ߤǤ衣äƤߤС狼Ǥ衣
;;          speedbar.el ߤ
;;
;;      (under-milk)
;;
;;          ɽʸ wine ǤϤʤmilk θ˽Ϥ
;;
;;      (timer n)
;;
;;			n ɽٱɽ
;;
;;  
;;
;;      Icΰ򡢥ܥ̾Ϥͳϡٶ
;;      ĤäΤǹܤѹƤƤӽФäȤˤϡ
;;      Ȥξ֤äƤԤǤ롣ꥹȤϥ
;;      ԡϤ櫓ǤϤʤǡʤȤϵʤä
;;      ʤäƤϡλͤϲ褦ʵ⤹뤷Ѥ­Ȥˤʤ
;;      Ƥޤä褦ʵ⤹뤬ѹưפǤϤʤޡ
;;
;;      ǯ塢λͤѤʥǥɤͭ뤳ȤȽ졣
;;
;;
;;   (define-key [S-f1] 'Ic-menu-insert  )   ; 
;;   ([M-f1]          Ic-menu-delete  )   ; 
;;   ([delete]        Ic-menu-push    )   ; Уգӣ
;;   ([insert]        Ic-menu-pop     )   ; Уϣ
;;   ([f1]            Ic-menu-insert  )   ; ɲ
;;   ([f7]            Ic-menu-short)      ; 硼ȥåȻ
;;   ([M-f7]          Ic-menu-short-del)  ; 硼ȥåȺ
;;   (format "%10s : %s\n" (U-map-to-keystr 'Ic-menu-insert  Ugdb-map)   "ܤɲ")
;;   (format "%10s : %s\n" (U-map-to-keystr 'Ic-menu-title       Ugdb-map)   "ȥѹ")
;;   (format "%10s : %s\n" (U-map-to-keystr 'Ic-menu-push        Ugdb-map)   "ܤƵХåե¸")
;;   (format "%10s : %s\n" (U-map-to-keystr 'Ic-menu-pop     Ugdb-map)   "Хåե餽")
;;   (format "%10s : %s\n" (U-map-to-keystr 'Ic-menu-short       Ugdb-map)   "硼ȥåȤ")
;;   (format "%10s : %s\n" (U-map-to-keystr 'Ic-menu-short-del   Ugdb-map)   "硼ȥåȤκ")
;;
;;
;;̴ؿǻȤؿ()
;;
;;
;;  (defvar Ic-return-key [return])
;;  (defconst Ic-name-milk " *Ic milk*")
;;  (defconst Ic-name-wine " *Ic wine*")
;;
;;  (catch 'Ic-NEXT t)              Ƥ򥭥󥻥뤷ƼΥХɤɤ߹
;;  (catch 'Ic-BREAK t)             Ƥ򥭥󥻥뤷ƥ饤֥λ
;;
;;  Хɤɤ߹
;;          
;;  (Ic-option 'before-exec) μ¹
;;          
;;  keybind  (Ic-idx 1) μ¹
;;          
;;  ⤷ (= nil Ic-ae) ʤ顢(Ic-option 'after-exec) μ¹(ꤷʤ¤ nil)
;;          
;;  Ic-keep-buffer ϡ˥塼λɽХåեݻ롣
;;          
;;  ⤷(eq Ic-refresh t)     ʤ˥塼κɽ(ꤷʤ¤ t)
;;  ⤷(eq Ic-refresh save)  ʤ˥塼κɽ(ꤷʤ¤ t) âɽΥХåե֤ϥפ롣
;;
;;  (before-exec    )   Хɤ줿ؿ¹Ԥ
;;  (after-exec     )   Хɤ줿ؿ¹Ԥ
;;  (start          )   ưȤ˼¹
;;  (end            )   Ic λȤɬ¹
;;  (refresh        )   Ρɤڤؤä˼¹
;;
;;
;;  (notcls-win)
;;
;;          軰 nil ξ Ic wine Хåե򥯥ꥢʤ
;;
;;   (save-node Ic-Table-list)
;;
;;          ˵ưȤ˥Ρɤΰ־Ƹ롣˻ꤵ
;;          Ƥͤϰ־Ϳ뤬ͼΤϽλκݤ Ufm 
;;          ưŪ¸ΤǵˤʤǤ
;;
;;   Ȥ
;;
;;  1997.12.21
;;
;;      ⤷顢ʤΤϤ⤦ȤäïäƤΤ
;;      ʤ⡢äΤȤԤ˶
;;      ƤϤʤϵ礭ʬ򤳤Υץߥ󥰤
;;      ƤΤơФοͤȴƤС
;;      ʵʬˤʤäƹ˵Ťʵ뤳Ȥ
;;
;;  1998.5.5
;;
;;      򤭤줤ˤˤƤäᤷϤʤ顢
;;      äȡХäƤ롣Ǥ⡢ˤˤϤʤ
;;      줬ޥ奢ץޡ졣
;;
;;  1999.3.5
;;
;;      ɽʤХ༣ޤǻ22ͤˤʤޤ
;;      Ƕ SNES ͷǤޤǤ⤳äƻ̵֤̤ʡ
;;
;;  2000.8.29
;;
;;      ǯ⤿ĤΤ⤦ͤ졣Ĺ
;;      ʤ롣ϥե꡼եȤꡢƤޤʤ
;;      Ƥ¼ռɤ߳ȤѤʤäƤ롣
;;
;;  2000.10.28
;;
;;      tree-mode ɲ
;;
;;  2001.02.17
;;
;;      customize бdefgroup  Ic ɲá
;;
;;  2001.10.23
;;
;;      start ץμ¹ԥߥ󥰤ѹ
;;      Ϥá⤦󤼤ͤˤʤäƤͤ
;;
;;

;;; Code:

(require 'misc-Uz)

;-------------------------------------------------------------------------------
;
;    :  ޥѿ
;
(defgroup Ic nil "Customization of the multI purpose object seleCtor { Ic }.")

(defcustom Ic-return-key	 [return]
	"˥塼ǹܤʤɥ꥿󥭡Ȥư륭"
	:group 'Ic :type 'sexp)

(defcustom Ic-recursive-key	 "\C-x\C-s"
	"˥塼ǺƵԽΰ٤Υ"
	:group 'Ic :type 'sexp)

(defcustom Ic-recursive-key2	 "\C-x\C-k"
	"˥塼ǺƵԽ󥻥ΰ٤Υ"
	:group 'Ic :type 'sexp)

(defcustom Ic-Face-cur       'R-Yellow
	"ο" :group 'Ic)

(defcustom Ic-Face-cur2      'R-Green
	"οʲߥΡɤȤ" :group 'Ic)

(defcustom Ic-Face-title     'R-Ic1
	"ȥСο" :group 'Ic)

(defface C-Blue '(
	(((class color)(background dark))	(:foreground "#00eeff"))
	(((class color)(background light))	(:foreground "#2277ff"))
    )
	"Ŀ" :group 'Ic)

(defface R-Blue '(
	(((class color)(background dark))	(:background "#00eeff"  :foreground "black"))
	(((class color)(background light))	(:background "#2277FF"))
    )
	"Ŀ ȿž" :group 'Ic)

(defface C-Red '(
	(((class color)(background dark))	(:foreground "#FF7777"))
	(((class color)(background light))	(:foreground "#AA0000"))
    )
	"ֿ" :group 'Ic)

(defface R-Red '(
	(((class color)(background dark))	(:background "#ff4030" :foreground "black"))
	(((class color)(background light))	(:background "#FFAAAA" :foreground "black"))
    )
	"ֿ ȿž" :group 'Ic)

(defface C-Yellow '(
	(((class color)(background dark))	(:foreground "#eeee44"))
	(((class color)(background light))	(:foreground "#aaaa11"))
    )
	"" :group 'Ic)

(defface R-Yellow '(
	(((class color)(background dark))	(:background "#d9de10" :foreground "black"))
	(((class color)(background light))	(:background "#eeee55" :foreground "black"))
    )
	" ȿž" :group 'Ic)

(defface C-Green '(
	(((class color)(background dark))	(:foreground "#10f010"))
	(((class color)(background light))	(:foreground "#009000"))
    )
	"п" :group 'Ic)

(defface R-Green '(
	(((class color)(background dark))	(:background "#10f010" :foreground "black"))
	(((class color)(background light))	(:background "#a0e0a0"))
    )
	"п ȿž" :group 'Ic)

(defface C-Purple '(
	(((class color)(background dark))	(:foreground "#ff80ff"))
	(((class color)(background light))	(:foreground "#e050e0"))
    )
	"翧" :group 'Ic)

(defface R-Purple '(
	(((class color)(background dark))	(:background "#ff80ff" :foreground "black"))
	(((class color)(background light))	(:background "#F060F0" :foreground "#00FF00"))
    )
	"翧 ȿž" :group 'Ic)

(defface R-Ic1 '(
	(((class color)(background dark))	(:foreground "#1111BB" :background "#C080E0"))
	(((class color)(background light))	(:foreground "#1111BB" :background "#C080E0"))
    )
	"ɽ" :group 'Ic)
;------------------------------------------------------------------------------------------

(defconst Ic-name-milk " *Ic milk*")
(defconst Ic-name-wine " *Ic wine*")

(defvar Ic-PP         nil)			; ץåݥåפΤѿ
(defvar Ic-before-rec-hook  nil)    ; ƵԽ˼¹Ԥեå
(defvar Ic-tajyuu   0)
(defvar Ic-hook   nil)

;-------------------------------------------------------------------------------
;
;    :  Х
;
;

(defvar Ic-mode-map (make-sparse-keymap))

;¹ԤȽλ
(define-key Ic-mode-map Ic-return-key		'Ic-exec        )
(define-key Ic-mode-map "q"                 'Ic-quit        )
(define-key Ic-mode-map "+"                 'Ic-resplit-a	)
(define-key Ic-mode-map "-"                 'Ic-resplit-b	)

;岼
(define-key Ic-mode-map [up]                'Ic-up          )
(define-key Ic-mode-map [down]              'Ic-down        )
(define-key Ic-mode-map "\C-p"              'Ic-up          )
(define-key Ic-mode-map "\C-n"              'Ic-down        )

;for term
(define-key Ic-mode-map "OA" 'Ic-up)
(define-key Ic-mode-map "OB" 'Ic-down)
(define-key Ic-mode-map "OC" 'Ic-right)
(define-key Ic-mode-map "OD" 'Ic-left)
(define-key Ic-mode-map [13] 'Ic-exec)
;(define-key Ic-mode-map [RET] 'Ic-exec)	;comment out for xemacs
(define-key Ic-mode-map [return] 'Ic-exec)

;װư
(define-key Ic-mode-map [(control up)]      'Ic-5-up        )
(define-key Ic-mode-map [(control down)]    'Ic-5-down      )

;
(define-key Ic-mode-map [right]             'Ic-right       )
(define-key Ic-mode-map [left]              'Ic-left        )
(define-key Ic-mode-map "\C-f"              'Ic-right       )
(define-key Ic-mode-map "\C-b"              'Ic-left        )

;Ρɰư
(define-key Ic-mode-map [(control right)]   'Ic-next-node   )
(define-key Ic-mode-map [(control left)]    'Ic-prev-node   )
(define-key Ic-mode-map [spase]             'Ic-next-node   )
(define-key Ic-mode-map [backspase]         'Ic-prev-node   )
(define-key Ic-mode-map "\M-n"              'Ic-next-node   )
(define-key Ic-mode-map "\M-p"              'Ic-prev-node   )

;ߤʸϤ򸡺
(define-key Ic-mode-map "\C-s"              (lambda () (Ic-write-wine (setq Ic-refresh nil)(isearch-forward))))
(define-key Ic-mode-map "\C-r"              (lambda () (Ic-write-wine (setq Ic-refresh nil)(isearch-backward))))
(define-key Ic-mode-map "\M-s"              (lambda () (Ic-write-wine (setq Ic-refresh nil)(isearch-forward-regexp))))
(define-key Ic-mode-map "\M-r"              (lambda () (Ic-write-wine (setq Ic-refresh nil)(isearch-backward-regexp))))


;̾򸡺ƹܤ˰ư
(define-key Ic-mode-map "\C-\M-r"           'Ic-search-b-IDX)
(define-key Ic-mode-map "\C-\M-s"           'Ic-search-f-IDX)
(define-key Ic-mode-map [(shift left)]      'Ic-search-b-IDX)
(define-key Ic-mode-map [(shift right)]     'Ic-search-f-IDX)

;ʸϤ򸡺ƹܤ˰ư
(define-key Ic-mode-map [tab]               'Ic-search-STR  )
(define-key Ic-mode-map [(meta down)]       'Ic-search-r-STR)
(define-key Ic-mode-map [(meta up)]         'Ic-search-b-STR)

(define-key Ic-mode-map [(meta right)]       'Ic-next-dsp)
(define-key Ic-mode-map [(meta left)]	     'Ic-prev-dsp)

;
(define-key Ic-mode-map [(shift down)]				'Ic-wine-sdown)
(define-key Ic-mode-map [(shift up)]				'Ic-wine-sup)
(define-key Ic-mode-map [next]              		'Ic-wine-sdown)
(define-key Ic-mode-map [prior]             		'Ic-wine-sup)
(define-key Ic-mode-map "\C-v"              		'Ic-wine-sdown)
(define-key Ic-mode-map "\M-v"              		'Ic-wine-sup)
(define-key Ic-mode-map [mouse-5]           		'Ic-wine-sdown)
(define-key Ic-mode-map [mouse-4]           		'Ic-wine-sup)
(define-key Ic-mode-map [double-mouse-5]    		'Ic-wine-sdown)
(define-key Ic-mode-map [double-mouse-4]    		'Ic-wine-sup)
(define-key Ic-mode-map [triple-mouse-5]    		'Ic-wine-sdown)
(define-key Ic-mode-map [triple-mouse-4]    		'Ic-wine-sup)
;
(define-key Ic-mode-map [end]	'Ic-wine-end)
(define-key Ic-mode-map [home]	'Ic-wine-home)

;ޥ
(define-key Ic-mode-map [down-mouse-1]      'Ic-mouse-1         )
(define-key Ic-mode-map [mouse-2]           'Ic-mouse-2         )
(define-key Ic-mode-map [double-mouse-2]    'Ic-mouse-2         )
(define-key Ic-mode-map [(control meta end)]'Ic-recursive-edit  )

;ե졼ֺƵԽ
;(define-key Ic-mode-map [switch-frame]      'Ic-recursive-edit	)

(defun Ic-recursive-edit ()
    (condition-case nil (handle-switch-frame last-input-event)(error))
    (message (concat "Ic : ƵԽޤɬ " (U-map-to-keystr 'exit-recursive-edit global-map) " ǡλƤ"))
    (if Ic-history (set-window-configuration Ic-history))
    (recursive-edit)
    )

;
(if (string-match "XEmacs" (version))(progn
    (defun read-event ()
        (let (( e (let ((a (next-event)))(while (not (key-press-event-p a))(setq a (next-event)))a)))
            (if (event-modifiers e)(append (event-modifiers e) (list (event-key e)))(list (event-key e)))
        )
    )))


(defun Ic-wine-home () 
	(Ic-write-wine (setq Ic-refresh nil)(goto-char (point-min)))
	)

(defun Ic-wine-end () 
	(Ic-write-wine (setq Ic-refresh nil)(goto-char (point-max)))
	)


;-------------------------------------------------------------------------------
;
;    :  ҤߤĤδؿ
;
;   ΥȤ뤱ɲɤʤȤΤǤ
;   Ĥˤϡ즤ǤȽʤäƻ⤢뤷Ȥ즤Ƥץ
;   Ǥ뤳ȤȽǤ
;
;	table  option Ȥǡ¤äŪ˸ľɬפ򴶤
;	ޤǤ⡢ Emacs Lisp ꤿʤʡGuile Emacs 
;	ڤޤ(ĥ)
;
(defun Ic (table option)
    "Ic menu is multi purpose Lisp OBJECT selector.
If you want to use this function , See Ic.el.
"   ;αѸɥˤäƤ롩
    (interactive)
	;եåμ¹
	(if Ic-hook(progn (run-hooks 'Ic-hook)(setq Ic-hook nil)))
    ;顼
    (cond   ((or(not (boundp table))(not (boundp option)))(message "ꤵƤʤ")(ding))
            ((boundp 'Ic-rec-flg)(message (concat "ƵԽ衣" (U-event-string Ic-recursive-key) "򲡤Ƥ"))(ding))
            (t
    ;¿ŸƤӽФϥɥƤȤ
    (if (< 0 Ic-tajyuu)(set-window-configuration Ic-history))
    ;¹Գ
    (let* (
        ;-------------------------------------------------------------------------------
        ;ѿ«
        (Ic-Table           table                                   )   ; ɽ
        (Ic-Option          option                                  )   ; ץ
        (Ic-IDX             0                                       )   ; 뤬ؤƤʣϤޤֹ
        (Ic-return          nil                                     )   ; 
        (Ic-quit            nil                                     )   ; ˥塼ФȤ˥åȤƤ
        (Ic-title-str       nil                                     )   ; Ƭɽ
        (Ic-max             0                                       )   ; ǿ
        (Ic-Table-list                                                  ; Ρɤ夬ȤΤΡϿѥå((table option IDX)()...)
            (let* (
                (OP(Ic-option 'save-node 1))                ;
                (B  (if OP (nth (1- (length OP)) OP)nil))                   ;ǸͤȤ
                )                                               ;IDX ˤĤƤϺǽͤȤ
            (if OP  (progn (setq Ic-Table (car B))(setq Ic-Option (nth 1 B))(setq Ic-IDX (nth 2 (car OP)))OP)
                    (list (list table option 0)))
            ))
        (Ic-win-milk        nil                                     )   ; milk window ưΥɥ
        (Ic-win-wine        nil                                     )   ; wine window äɥ
        (Ic-before-buffer   (current-buffer)                        )   ; ưХåե
        (Ic-history         (current-window-configuration)          )   ; ưΥɥ
        (Ic-owin            nil                                     )   ; ưΤ¾Υɥ
        (Ic-keep-buffer     nil                                     )   ; λ˳ϤȤϰ㤦Хåեɽ
        (Ic-keep-windows    nil                                     )   ; λ˳ϤȤϰ㤦ɥɽ
        (Ic-wink            nil                                     )   ; wink mode  ʬ milk ɥ
        (Ic-milk-list       nil                                     )   ; wink mode  ʬ milk ꥹ(뤫)
        (Ic-no-wine         nil                                     )   ; wine ɥɽ򤷤ʤ

        (Ic-keymap          nil                                     )   ; ȼΥޥå
        (Ic-local-keymap    nil                                     )   ; 륭ޥå
        (Ic-lines           nil                                     )   ; ɽԿ¸å (2 3 4 ...)

        (Ic-refresh         t                                       )   ; ¹Ը t ϥեå(default) save  wineɽϰ֤¸
        (Ic-before-exec     nil                                     )   ; ¹ ɾ
        (Ic-after-exec      nil                                     )   ; ¹Ը ɾ
        (Ic-ae			    nil                                     )   ; ¹Ը ɾʤե饰
        (Ic-first           t                                       )   ; ϤƤɤΥե饰
        (Ic-short-cut       nil                                     )   ; 硼ȥåȤɾꥹȤ⤷ϥ硼ȥåǧѥե饰
        (Ic-short-disp      nil                                     )   ; 硼ȥåȤɽ뤫ɤ
        (Ic-null-format     '(format "----< %d >----" Ic-IDX)       )   ; ܤɽʸnilλμ¹ԥꥹ

        (Ic-wink-ofs        0                                       )   ; ڡΤλϤޤIDX
        (echo-keystrokes    0                                       )   ; ѤΤǤ

        (Ic-directory-wine  (if (get-buffer Ic-name-wine)           ; ǥ쥯ȥ¸
                (save-excursion (set-buffer (get-buffer Ic-name-wine))default-directory)))
        (Ic-directory-milk  (if (get-buffer Ic-name-milk)           ; ǥ쥯ȥ¸
                (save-excursion (set-buffer (get-buffer Ic-name-milk))default-directory)))

        (Ic-local-map-wine  (if (get-buffer Ic-name-wine)           ; ޥåפ¸
                (save-excursion (set-buffer (get-buffer Ic-name-wine))(current-local-map))))
        (Ic-local-map-milk  (if (get-buffer Ic-name-milk)           ; ޥåפ¸
                (save-excursion (set-buffer (get-buffer Ic-name-milk))(current-local-map))))

;       (Ic-recbuf-wine (if (and (boundp 'Ic-rec-flg) (get-buffer Ic-name-wine))    ; ХåեƤ¸
;               (save-excursion (set-buffer (get-buffer Ic-name-wine))(buffer-string))
;               ))
;       (Ic-recbuf-milk (if (and (boundp 'Ic-rec-flg) (get-buffer Ic-name-milk))    ; ХåեƤ¸
;               (save-excursion (set-buffer (get-buffer Ic-name-milk))(buffer-string))
;               ))

;       (Ic-history-win     nil                                     )   ;!!!
;       (Ic-history-refresh     nil                                 )   ;!!! ɥʤɤѹˤϤ¹Ԥ롣
        )
        ;-------------------------------------------------------------------------------
        ;ߥ˥ХåեθƤӽФϡߥ˥ХåեΥɥƨ
        (if (window-minibuffer-p (selected-window))(progn (while (window-minibuffer-p (selected-window))(other-window 1))(delete-other-windows)))
        ;
        (unwind-protect (progn
        (setq Ic-tajyuu (1+ Ic-tajyuu))
        (walk-windows (lambda (WIN)(if (eq WIN (selected-window))()(setq Ic-owin (append Ic-owin (list WIN))))))
        (if (Ic-option 'start 0)(mapcar (function eval) (Ic-option 'start 1 nil t)))
        (Ic-refresh)
        (setq major-mode            'Ic-mode                )
        (setq mode-name             "Ic"                    )
        (catch 'Ic-BREAK (let ((KEY nil)(PREFIX nil)                )
        ;ᥤ롼
        (condition-case nil (while t
            (if Ic-quit     (throw 'Ic-BREAK t))    ; λ
            (if Ic-return   (throw 'Ic-BREAK t))    ; λ
            (setq KEY (vector (read-event)))        ; ٥ȼ
            ;ޥɸ
            (let((func))(cond
                ((and (keymapp PREFIX)              (setq func (lookup-key PREFIX KEY t))(not (numberp func))))	; prefix    map
                ((and (keymapp Ic-local-keymap)     (setq func (lookup-key Ic-local-keymap KEY t))(not (numberp func))))	; point     map
				((and	(consp Ic-keymap)
						(setq func (catch 'G (mapcar (lambda(m)(if (and (keymapp m)(setq m (lookup-key m KEY t)))(throw 'G m))) Ic-keymap)(throw 'G nil)))
						(not (numberp func)))
						)
                ((and (not(Ic-option 'no-keymap))   (setq func (lookup-key Ic-mode-map KEY t))(not (numberp func))))	; global    map
                ((and Ic-short-cut (let ((I Ic-IDX)(NUM(elt KEY 0)))(cond													; short cut
                    ((catch 'SHORT (while(< I Ic-max)(if (eq (Ic-idx 8 I)NUM)(throw 'SHORT t))(setq I (1+ I))))
                            (Ic-short-sub I))               ;specify
                    ((and(numberp NUM)(setq NUM (cond
                        ((and (>= NUM 48)(<= NUM  57))(string-to-number (char-to-string NUM)))
                        ((and (>= NUM 97)(<= NUM 122))(+ (- NUM 97)10))
                        ((and (>= NUM 65)(<= NUM  90))(+ (- NUM 65)36))
                        )))
                            (if NUM (Ic-short-sub NUM)))    ;not specify
                    ))))
                )
            ;¹
            (catch 'Ic-NEXT (cond
                ((null func)    (throw 'Ic-NEXT t))     ; no function
                ((numberp func) (throw 'Ic-NEXT t))     ; why we need?
                ((keymapp func)(setq PREFIX func))      ; prefix
                (t  (if Ic-before-exec (mapcar (lambda (l)(eval l)) Ic-before-exec))                                               ; ¹

                    (condition-case VAR (funcall func)														; ؿ¹
                        (error (message "")(princ (concat "Ic exec error : " (error-message-string VAR)))(ding))
                        (quit (ding))
                        )

                    (setq PREFIX nil)       ; ¹
                    (if Ic-ae (setq Ic-ae nil)(if Ic-after-exec (mapcar (lambda(l)(eval l))Ic-after-exec)))                       ; ¹
                    (if(eq t Ic-keep-buffer)(setq Ic-keep-buffer (current-buffer)))							; Хåե¸
                    (if Ic-quit nil (cond   
							; λǤʤХեå夹
							((eq Ic-refresh t)(Ic-refresh))			
							; Хåեΰ֤ѹ
                            ((eq Ic-refresh 'save)
                                    (let ((START (window-start Ic-win-wine)))
                                    (Ic-refresh)
                                    (set-window-start Ic-win-wine START)))
							; ɽХåեΰŪѹ
							((stringp Ic-refresh)(let ((f Ic-refresh))(Ic-refresh)(select-window Ic-win-wine)(switch-to-buffer f)(select-window Ic-win-milk)))
							; ˥եå夹
                            ((eq Ic-refresh nil)(setq Ic-refresh t))
                        )	; Ic-name-def ꤵƤ顢ɽ
						(if (and Ic-name-def (get-buffer Ic-name-def)) (progn (select-window Ic-win-wine)(switch-to-buffer Ic-name-def)(select-window Ic-win-milk)))
						)
                    )
                ))
            ))(quit(ding)(message "Ic 饤֥Ǥ"))))))
        ;-------------------------------------------------------------------------------
        ;λݾ
        (mapcar (lambda (SYM)(unintern (symbol-name SYM)))Ic-temp-symbols)(setq Ic-temp-symbols nil)
        (setq Ic-tajyuu (1- Ic-tajyuu))
        (if (eq 0 Ic-tajyuu)(progn
            ;ȥåץ٥θƤӽФξ
            (set-window-configuration (if Ic-keep-windows Ic-keep-windows Ic-history))
            (if Ic-keep-buffer (switch-to-buffer Ic-keep-buffer))
            (let ((BUFF (get-buffer Ic-name-milk)))(if BUFF (kill-buffer BUFF)))    ; ȥХåեκ
            (let ((BUFF (get-buffer Ic-name-wine)))(if BUFF (kill-buffer BUFF)))    ; ȥХåեκ
            );¿ŸƤӽФξ
            (let ((BUFF (get-buffer Ic-name-milk)))(if (and BUFF Ic-directory-milk)
                (save-excursion
                    (set-buffer BUFF)
                    ;(if (boundp 'Ic-rec-flg)(erase-buffer)(insert Ic-recbuf-milk))
					(use-local-map Ic-local-map-milk)
                    (setq default-directory Ic-directory-milk)
                    )))
            (let ((BUFF (get-buffer Ic-name-wine)))(if (and BUFF Ic-directory-wine)
                (save-excursion
                    (set-buffer BUFF)
                    ;(if (boundp 'Ic-rec-flg)(erase-buffer)(insert Ic-recbuf-wine))
					(use-local-map Ic-local-map-wine)
                    (setq default-directory Ic-directory-wine)
                    )))
            )
            ;Ρɤε(Ǿ̥ΡɤѿˤޤʤȤʤ)
            (let ((SY (nth 1 (nth 0 Ic-Table-list))))(if (Ic-option 'save-node 0 (eval SY))(progn
                (set SY (U-del3 'save-node (eval SY)))            ;save-node ιõ
                (setq Ic-Table-list (append (list (list
                        (nth 0(car Ic-Table-list))(nth 1 (car Ic-Table-list)) Ic-IDX))
                        (cdr Ic-Table-list)));ǽIDX򸽺ߤͤѹ(ǽ IDX ϻȤʤΤǤǻѤ)
                (set SY (append (eval SY) (list (list 'save-node Ic-Table-list))))
                )))
        )
        (if (Ic-option 'end)(mapcar (lambda (l) (eval l))(Ic-option 'end 1 nil t)))
        Ic-return
    ))))
;-------------------------------------------------------------------------------
;
;    :  硼ȥåȼ¹
;
;	δؿϡºݤ IDX ǻꤵ줿ܤɽơ
;	줬¹Ԥ줿Τ褦˿񤦡
;	func ˴ؿꤷʤΤ̾롼Ǥϼ¹ԤϹԤʤ
;	before-exec ʤɤϺΤȤ¹ԤάƤΤǴˤƱǤϤʤ
;
(defun Ic-short-sub (IDX)
    (if (> Ic-max IDX)(let (func)
		(Ic-before-cur)
		(setq Ic-IDX IDX)
		(Ic-after-cur)
		(cond
		    ((listp Ic-short-cut)(mapcar (function eval) Ic-short-cut))				;ä
		    ((Ic-next-node))														;Ρɲ
			((and	(consp Ic-keymap)												;꥿󥭡줿ΤȲ
						(setq func (catch 'G (mapcar (lambda(m)(if (and (keymapp m)(setq m (lookup-key m Ic-return-key t)))(throw 'G m))) Ic-keymap)(throw 'G nil)))
						(not (numberp func)))
						(funcall func))
		    (t(Ic-exec))															;ݥȼ¹
			)
		(Ic-refresh)
	)))

;-------------------------------------------------------------------------------
;
;    :  եå塣ɤʾ֤Ǥ⸵ɤᤷƤޤŤ
;           ɽƤѹʤ¤ꡢФʤǺѤޤΤ
;
;	(defvar Ic-refresh	nil)	ɽʤ
;						t			(ǥե)
;						'save	Хåե Ic-name-wine ɽϰ֤¸
;						"buff"	Хåեɽ
;
;	Ic-keep-buffer		Ic λ˻Хåեɽ
;
;	Ic-noaf				wine ˽ʤtꤹ
;
;	(notcls-win)		table[3]==nil λ˥Хåե򥯥ꥢʤ
;
;	Ic-name-def			Ic-name-wine ˾ɽХåե̾
;
(defvar Ic-name-def nil)

(defun Ic-refresh ()
    (interactive)
	(let (
		Ic-refp ;	եåɽե饰Ufm-update ǻѤ
		(timer (eval (Ic-option 'timer 1)))		; ٱɽԿ(̤)
		)

    ;ɥ
    (Ic-window)

	;Ϥ˼¹Ԥ٤(Ic-milkȥХåեˤʤ)
    (if Ic-first (progn (setq Ic-first nil)(if (Ic-option 'refresh)(mapcar (function eval) (Ic-option 'refresh 1 nil t)))))

    ;Ƽѿ

;    (setq Ic-keymap (nth 1 (assoc 'keymap (eval Ic-Option))))
;	(while (and (not (null Ic-keymap))(not (keymapp (setq Ic-keymap (condition-case nil (eval Ic-keymap)(error)))))))
	(setq Ic-keymap (mapcar (lambda (k)
		(while (and (not (null k))(not (keymapp (setq k (condition-case nil (eval k)(error)))))))
			k)
		(nthcdr 1 (assoc 'keymap (eval Ic-Option)))
		))
	(if (car Ic-keymap) (use-local-map (car Ic-keymap)))

    (setq Ic-before-exec    (Ic-option 'before-exec 1 nil t))
    (setq Ic-after-exec     (Ic-option 'after-exec 1 nil t))
    (setq Ic-short-cut (let ((CUT (Ic-option 'short-cut 1 nil t)))(if CUT CUT (Ic-option 'short-cut 0))))
    (setq Ic-short-disp (Ic-option 'short-disp 0))
    ;ȥʸ
    (erase-buffer)
	(setq truncate-lines t)
    (let((STR (Ic-option 'title 1)))
        (setq Ic-title-str (if(stringp STR)STR(eval STR))))
    (if Ic-title-str (progn
        (insert Ic-title-str)
        (if (Ic-option 'title 2)()
            (let ((X (/ (- (window-width) (current-column) Ic-wink 2) 2)))
                (if (< 0 X)(let ((SPC (make-string X ?\ )))(insert SPC)(beginning-of-line)(insert SPC)))))
        (put-text-property (point-min) (point-max) 'face Ic-Face-title nil)
        (goto-char (point-max))
        (insert "\n")
    ))
	; NEST : 
	;  (0)
	;  (1)
	;  (2)
	;  (2 0)
	;  (2 1)
	;  (2 2)
	;  (2 3)
	;  (2 3 0)		(Ic-table nil 2 nil 3 0)
	;  (2 4)
	;  (2 4 1)
	;  (2 5)
	;  (2 6)
	;  (3)
	;  (3 0)
	;  (3 1)
	;  (3 2)
	;  (4)
	;  (5)
	; LL : ԤΤʤޤʤ LL : (nil t nil t t) ϡ"      "  nil
	; o  : ιԤɽܤ
	; NOW: ɽ
	; I  : Կ


	;ʸ
    (setq Ic-lines nil)
    (let ((OLD Ic-IDX)o(LL nil)(NEST (list 0))NOW)
	    (setq Ic-IDX 0)
		(catch 'B (while t
		;get table
		(while  (not (setq NOW (Ic-table nil NEST)))			;θõ
				(if (eq 1 (length NEST))(throw 'B t))			;ꥹȤʤнλ
				(U-del NEST -1)		;ꥹȤκǸ macro
				(U-add-end NEST)	;ꥹȤκǸ1 macro
				(if (eq 0 (length LL))(setq LL nil)(U-del LL -1))					;ꥹȤκǸ
				)
        ;save line
        (setq Ic-lines (append Ic-lines (list (1+ (count-lines (point-min) (point))))))

        ;short cut
        (if Ic-short-disp (insert (concat "["(cond
            ((nth 8 NOW)(let ((CH (nth 8 NOW)))(if (numberp CH)(char-to-string CH)(prin1-to-string CH)))) ;short cut
            ((and (<= 0 Ic-IDX)(>= 9 Ic-IDX))     (number-to-string Ic-IDX))       ;0-9
            ((and (<= 10 Ic-IDX)(>= 35 Ic-IDX))   (char-to-string (+ 87 Ic-IDX)))  ;a-z
            ((and (<= 36 Ic-IDX)(>= 61 Ic-IDX))   (char-to-string (+ 29 Ic-IDX)))  ;A-Z
            (t " "))
            "] ")))

		;ΥΡɤǻĤɽܤ뤫ʡ
		(let ((A (apply 'list NEST)))
				(U-add-end A)(setq o (Ic-table nil A))
				)
        ;tree
        (if (Ic-option 'tree)(let (z l (a 0))
            (setq l (1- (length NEST)))(while (> l a)(insert (if (nth a LL)"  """))(setq a (1+ a)))
            (insert (if (and (not z) o)""""))
            (insert (if (and (nth 3 NOW)(nth 10 NOW))" " " "))
            ))

        ;ɽʸ
		(let ((STR (car NOW))) (insert
            (cond   ((null		STR)	(eval Ic-null-format)												)
                    ((stringp	STR)	STR																	)
                    ((atom		STR)	(prin1-to-string (eval STR))										)
                    ((listp		STR)	(let ((RET(eval STR))) (if (stringp RET)RET (make-string 10 ?*)))	)
        )))
        (insert "\n")

        ;color
        (let ((option (nth 7 NOW)))
            (if option
            (mapcar (lambda (a)(Ic-paint (+ (nth Ic-IDX Ic-lines) (nth 0 a))(nth 1 a)(nth 2 a)(nth 3 a))) option)
            )(goto-char(point-max)))

		;next
		(if (and (Ic-option 'tree)(nth 3 NOW)(nth 10 NOW))(progn
			;ΥΡɤɽ֤ʤ
			(setq LL (append LL (list (eq nil o))))
			(setq NEST (append NEST (list 0)))													;ꥹȤκǸ(0)ɲ
			)
			;Ρɤɽʤ
			(U-add-end NEST)			;ꥹȤκǸ1
			)
		(setq o nil)
		(setq Ic-IDX (1+ Ic-IDX))
        ))
	(setq Ic-max Ic-IDX)
	(setq Ic-IDX (if(>= OLD Ic-IDX)(1- Ic-IDX) OLD))	;Ic-IDX 
	(if (< Ic-IDX 0)(setq Ic-IDX 0));ޤˤλ֤ ܿλ
    )
    ;

	;wine ɥ
	(Ic-after-cur)

	;եåϾˤΤ
    (setq Ic-refresh t)
    ))

;ǽεưǤϤʤץ
;
;   (refresh ()(Ic-refresh))
;
;Τ褦Ǥ褦ˤȡǽϥСʤΤ
;Ic-max  0 ˤʤäƤޤäOLD  -1 ȤʤΤǡ˾˰ư
;Ȥ˷Ƥޤ

;-------------------------------------------------------------------------------
;
;   ̾ :  ɥʥեåΤȤ˸ƤФ
;
;    :  ɥϰٵưξ֤ᤵơޤľ
;           ɥ(ХåեȰ)ϡʤ褦ˤ롣
;
;   Ic-win-wine ͤϡIc κƵƤӽФԤäϰΥ
;   ɥͤˤʤäƤϤ뤬 Ic-win-wine  Ic-refresh
;   ΤȤѹΤǡºݤˤϻȤʤѿǤ뤳Ȥա
;
(defun Ic-window ()
    ;¾Υɥ¸
    (let (NEW)
        (mapcar
            (lambda (TMP)(if (window-live-p TMP)(setq NEW (append NEW (list
                (`((, TMP) (,(window-buffer TMP)) (,(window-start TMP))))
                )))))
            Ic-owin)
        (set-window-configuration Ic-history)
        (mapcar
            (lambda (TMP) (if (window-live-p (nth 0 TMP))(progn
            ;(message (prin1-to-string TMP))
            (set-window-buffer (nth 0 TMP)(nth 1 TMP))(set-window-start (nth 0 TMP)(nth 2 TMP)))))
            NEW)
        )

    ; wine ɥȥХåեκ
;   (if (and Ic-history-win (not Ic-history-refresh))   ;!!!
;       (set-window-configuration Ic-history-win)           ;!!!

    (setq Ic-no-wine (Ic-option 'no-wine))
    (if (null Ic-no-wine)
    (let*(
        (Ic-horizontal (Ic-option 'vertical 0))
        (Ic-milk-width (Ic-option 'milk-width 1))   ; ͥ
        (Ic-wine-width                                  ; 
            (let ((MILK (Ic-option 'wine-width 1)))
            (if MILK MILK
                    (*
                        (if (Ic-option 'wine-split 0)(Ic-option 'wine-split 1)1)
                        (/  (if Ic-horizontal(window-width)(window-height))
                            (if (Ic-option 'wine-split 0)(Ic-option 'wine-split 2)2)
                ))))))
    (switch-to-buffer   (get-buffer-create Ic-name-wine))
    (setq tab-width 4)                                      ; tab
    (let ((LINE (Ic-option 'wine-mode-line 1)))         ; mode line
		(if (symbolp LINE)(setq LINE (eval LINE)))
        (if LINE (progn(setq mode-line-format LINE)(force-mode-line-update))))
    (setq truncate-lines (Ic-option 'wine-cut 0))       ; cut lines
    (setq Ic-win-milk (selected-window))                ; window name

    (condition-case
        nil
        (setq Ic-win-wine                               ; split window
            (split-window (selected-window)
                (if Ic-milk-width Ic-milk-width
                (- (if Ic-horizontal (window-width) (window-height)) Ic-wine-width))
                Ic-horizontal))
        (error (message "ɥλޤǤ")
            (setq Ic-win-wine
                (split-window (selected-window)
                (/ (if Ic-horizontal (window-width) (window-height)) 2)
                Ic-horizontal))
        ))
    ))
;   (setq Ic-history-win (current-window-configuration)))   ;!!!

    ; milk Хåեκ
    (switch-to-buffer   (get-buffer-create Ic-name-milk))
    (setq tab-width 4)                                                                      ; tab
    (setq truncate-partial-width-windows (Ic-option 'milk-cut 0))                       ; cut lines
    (let ((LINE (Ic-option 'milk-mode-line 1)))(if LINE (progn(setq mode-line-format LINE)(force-mode-line-update))))   ; mode line

    ; wink ⡼ɤλΥɥʬ
    (setq Ic-wink                                                   ; set width
            (cond   ((Ic-option 'wink 1)(eval (Ic-option 'wink 1)))
                    ((Ic-option 'wink-less 1)(1-(/(window-width)(eval (Ic-option 'wink-less 1)))))
                    (t 1)
            ))
    ; wink mode
    (let ((tmp-hist (current-window-configuration)))(if (< 1 Ic-wink) (Ic-wink-mode)))
    )

;-------------------------------------------------------------------------------
;
;    :  ɥʬ䤹롣ʤСʬ򸺤餷ƹԤ
;           ʬǤʤСIc-wink  1 ꤹ롣
;
(defun Ic-wink-mode ()
    (catch 'BREAK (condition-case nil
    (progn
        (set-window-configuration tmp-hist)
        (setq Ic-milk-list (list Ic-win-milk))
        (let ((I 1)(WIDTH (/ (window-width) Ic-wink)))(while (not(eq I Ic-wink))
            (setq Ic-milk-list (append Ic-milk-list (list
                (split-window (selected-window) WIDTH t))))
            (select-window (nth (1- (length Ic-milk-list)) Ic-milk-list))
            (setq I (1+ I))
            ))
        (setq Ic-wink-ofs 0);Ƭ᤹
        )
    (error (progn (setq Ic-wink (1- Ic-wink))
            (if (> 2 Ic-wink)(progn(setq Ic-wink 1)(throw 'BREAK t)))); 2 > ϾĹ
            (Ic-wink-mode)
        )
    ))
    (select-window (get-buffer-window Ic-name-milk))
    )

;-------------------------------------------------------------------------------
;
;    :  οä
;
;
(defun Ic-face-del (idx)

    ;erase face
    (let ((line (if (nth Ic-IDX Ic-lines)   ;Because if there is no element,nth Ic-lines is nil.
                (nth Ic-IDX Ic-lines)
                (1+ (count-lines (point-min) (point))))
        ))
    (goto-line line)
	(if (null window-system) 
		nil;(while (eq 62 (char-after))(delete-char 1))
    (let((x)(y))
        (setq x (point))
        (goto-line (if (nth (1+ Ic-IDX) Ic-lines)(nth (1+ Ic-IDX) Ic-lines)(1+(count-lines (point-min) (point-max)))))
        (setq y (point))
        (remove-text-properties x y '(face nil))
    ))
    ;If specified rest
    (let ((option (Ic-idx 7)))    ;When emphasize is specified.
            (if option
            (mapcar (lambda (a)(Ic-paint (+ line (nth 0 a))(nth 1 a)(nth 2 a)(nth 3 a))) option)
            ))
    ))
(defun Ic-face ()           ;οդ
    (let ((line (if (nth Ic-IDX Ic-lines)   ;Because if there is no element,nth Ic-lines is nil.
                (nth Ic-IDX Ic-lines)
                (1+ (count-lines (point-min) (point))))
        ))
        (if(null (Ic-idx 6))      ;When emphasize is not specified.
        (let((x)(face  (if(Ic-idx 3)Ic-Face-cur2 Ic-Face-cur)))
            (Ic-paint line 0 'end face)
            )
        (let ((option (Ic-idx 6)))    ;When emphasize is specified.
            (mapcar (lambda (a)(Ic-paint (+ line (nth 0 a))(nth 1 a)(nth 2 a)(nth 3 a))) option)
            )
    )))

(defun Ic-paint (line top end face)     ;դ
    (let ((x))
        ;start
        (goto-line line)
	(if (null window-system)
		nil;(progn (if (eq 62 (char-after))nil(insert ">")(backward-char 1)))
        (move-to-column top)
        (setq x (point))
        ;end
        (beginning-of-line)
        (cond   ((eq end 'end)  (end-of-line))
                ((eq end 'last) (condition-case nil (goto-line (nth (1+ Ic-IDX) Ic-lines))(error (goto-char (point-max)))))
;                (t              (condition-case nil (forward-char end)(error))))			λͤϷݤ
                (t              (move-to-column end)))
        ;paint
        (put-text-property  x (point) 'face face nil)
    )))
    ;(Ic-paint 0 1 'end Ic-Face-cur2)

;-------------------------------------------------------------------------------
;
;    :  񤭹
;
;
(defun  Ic-before-cur ()                ;ư˼¹
    (Ic-face-del Ic-IDX)
    )
(defvar Ic-noaf nil)					; wine ˽񤭹߰٤ʤˤtꤹ
(defun  Ic-after-cur ()                 ;ư˼¹
    ;뿧
    (Ic-face)
    ;Хåե˽񤭹
    (if (and (not Ic-noaf)(null Ic-no-wine))(progn
    (select-window Ic-win-wine)(switch-to-buffer Ic-name-wine)
    (let ((EXEC (Ic-idx 2)))
    (cond
            ; nil ʤХåեõ
            ((null      EXEC)   (if (Ic-option 'notcls-win 0)()(erase-buffer)))
            ; ٥ϥľɽ
            ((vectorp   EXEC)   (erase-buffer)(insert(U-vector-to-keystr EXEC)))
            ; ʸʤ餽Τޤɽ
            ((stringp   EXEC)   (erase-buffer)(insert EXEC))
            ; ȥʤѿƤɽ ؿ̾ʤ饭Хɤɽ
            ((atom      EXEC)   (erase-buffer)(insert (concat
                (prin1-to-string (if (boundp EXEC)(eval EXEC)EXEC))
                " "(if (functionp EXEC)(U-map-to-keystr EXEC global-map))
                )))
            ; ꥹȤξ硢¹Է̤ɽ
            ((listp     EXEC)   (condition-case nil(if (null (car EXEC))
                                    (eval(cdr EXEC))		;ǻϤޤꥹȤñ˼¹
                                    (let ((STR (eval EXEC)));¹Է̤ɽ
										(erase-buffer)
										(insert (if (stringp STR)STR(if STR (prin1-to-string STR)"")))		; nil ɽʤ
								))
                                ;ɾ顼
                                (error
                                    (erase-buffer)(insert (prin1-to-string EXEC))
                                    (ding)
                                    (message "ؤƤʴؿꤵƤ"))
                                ))
            ; ¾(ɽ)
            (t                  (erase-buffer)(insert(prin1-to-string EXEC)))
        ))
    (if (Ic-option 'notcls-win 0)()(goto-char (point-min)))
    )(setq Ic-noaf nil))

	;wink mode ιԤ·
    (if (< 1 Ic-wink)
        (let ((I 0)(HEIGHT (progn (select-window (car Ic-milk-list))(1- (window-height)))));window has mode line
            (setq Ic-wink-ofs (*(* Ic-wink HEIGHT)(/ Ic-IDX (* Ic-wink HEIGHT))))
            (while (not(eq I (length Ic-milk-list)))
                (select-window (nth I Ic-milk-list))
                (goto-line (+ 1 (* I HEIGHT) Ic-wink-ofs))(recenter 0)
                (setq I (1+ I))
            )))

    (select-window Ic-win-milk)

    ;륭ޥåפ
    (setq Ic-local-keymap (Ic-idx 9))
    )
;-------------------------------------------------------------------------------
;
;    :  ̥
;

(defun Ic-quit (&optional RET)      ;ޤ
    (interactive)
    (setq Ic-refresh nil)
    (if RET (setq Ic-return RET))
    (setq Ic-quit t)
    )

(defun Ic-exec (&optional IDX)      ;¹
    (interactive)
    (let ((FUNC (Ic-idx 1 IDX)))
    (cond
        ((null  FUNC)t)
        ((and (listp FUNC)(null(car FUNC)))         (eval (cdr FUNC)))                                  ; ɾ
        ((and (listp FUNC)(not (null(car FUNC))))   (eval FUNC)(setq Ic-quit t))                        ; ɾ꥿
        (t                                          (setq Ic-return FUNC)(setq Ic-quit t))              ; ¾
    )))

(defun Ic-up (&optional N)          ;źϸ
    (interactive)
    (Ic-before-cur)
    (if N ()(setq N 1))
    (setq Ic-IDX (let ((ANS (- Ic-IDX N)))(if(< ANS 0)(+ Ic-max ANS)ANS)))
    (setq Ic-refresh nil)
    (Ic-after-cur)
;    (setq Ic-ae t)		; ưΥǥեѤޤ
    )

(defun Ic-down (&optional N)        ;ź
    (interactive)
    (Ic-before-cur)
    (if N ()(setq N 1))
    (setq Ic-IDX (let ((ANS (+ Ic-IDX N)))(if(>= ANS Ic-max)(- Ic-max ANS)ANS)))
    (setq Ic-refresh nil)
    (Ic-after-cur)
;    (setq Ic-ae t)
    )

(defun Ic-right ()                  ;
;    (cond
;		((and (eq 1 Ic-wink)(Ic-option 'tree))(Ic-wink-next))
;		((eq 1 Ic-wink)(Ic-next-node))
;		(t (Ic-wink-next))
;		)
	(if (eq 1 Ic-wink)(Ic-next-node)(Ic-wink-next))
    )
(defun Ic-left ()                   ;
;    (cond
;		((and (eq 1 Ic-wink)(Ic-option 'tree))(Ic-wink-prev))
;		((eq 1 Ic-wink)(Ic-prev-node))
;		(t (Ic-wink-prev))
;		)
    (if (eq 1 Ic-wink)(Ic-prev-node)(Ic-wink-prev))
    )

(defvar Ic-temp-symbols ())
(defun Ic-next-node ()              ;ʼΥΡɤء
    (interactive)
    (if (Ic-option 'tree)(if (Ic-idx 3)(progn (Ic-idx 10 nil nil t t)(setq Ic-first t)))
    (let(( NEXT-LST (Ic-idx 3))(NEXT-OPT(nth 4(nth Ic-IDX (eval Ic-Table)))))
        (cond
            ((null NEXT-LST)nil)	;((null NEXT-LST)(message "ΥΡɤϤʤ")nil) ;åϽФʤ褦ˤ
            ((symbolp NEXT-LST)
                (setq Ic-Table-list (append Ic-Table-list (list (list NEXT-LST NEXT-OPT Ic-IDX))))
                (setq Ic-Option NEXT-OPT)
                (setq Ic-Table  NEXT-LST)
                (setq Ic-IDX 0)
                (setq Ic-first t)
                )
            ((listp NEXT-LST)   ;ꥹȤΤΤϿƤϡѿ setq 롣
                (setq Ic-Option (intern (make-temp-name "Ic")))(set Ic-Option (if (symbolp NEXT-OPT)(eval NEXT-OPT)NEXT-OPT))
                (setq Ic-Table  (intern (make-temp-name "Ic")))(set Ic-Table  (if (symbolp NEXT-LST)(eval NEXT-LST)NEXT-LST))
                (setq Ic-temp-symbols (append Ic-temp-symbols (list Ic-Table Ic-Option)))
                (setq Ic-Table-list (append Ic-Table-list (list (list Ic-Table Ic-Option Ic-IDX))))
                (setq Ic-IDX 0)
                (setq Ic-first t)
                )
        ))))

(defun Ic-prev-node (&optional N F)   ;ʾΥΡɤء
    ; +N  N ܤ˰ư 0 ϰֺǽΥΡɡ-N  N äƤ
    ; ((1st-table 1st-opt 0)(2st-table 2st-opt 1st-idx) ... )Τ褦˳ǼƤ
	; F ꤵƤ tree ⡼ɤλˤ⡢Ρɤ򲼹ߤ
    (interactive)
    (if (and (not F)(Ic-option 'tree))(progn (if (Ic-idx 10)(Ic-idx 10 nil nil t nil)

	(let* (
		(A (elt (Ic-xdi Ic-IDX (eval Ic-Table) 0 (list 0) 0 (list 0)) 0))
		(B (nth (1- (length A)) A))
		(C )
		)
		(if (eq (length A) 1)nil
		(U-del A -1)
		(setq C (Ic-table nil (if A A (list B))))
		(U-mod C 10 nil)
		(setq Ic-IDX (- Ic-IDX (1+ B)))
		(if (< Ic-IDX 0)(setq Ic-IDX 0))
		))
	))
    (if N ()(setq N -1))
    (if (< N 0);ޥʥ
    (if (>= (- N) (length Ic-Table-list))		nil;(message "Ρɹ߲Ǥʤ")
        (while (not (eq 0 N))
        (setq Ic-IDX    (nth 2 (nth (1- (length Ic-Table-list))Ic-Table-list)))
		(U-del Ic-Table-list -1)
        (setq Ic-Table  (nth 0 (nth (1- (length Ic-Table-list))Ic-Table-list)))
        (setq Ic-Option (nth 1 (nth (1- (length Ic-Table-list))Ic-Table-list)))
        (setq N (1+ N))
    ));ץ饹
        (if (< N 0)()
        (setq Ic-IDX    (nth 2 (nth (- (length Ic-Table-list) N 1)Ic-Table-list)))
        (let ((M (- (length Ic-Table-list) N)))(while (> M 1)(U-del Ic-Table-list -1)(setq M (1- M))))
        (setq Ic-Table  (nth 0 (nth N Ic-Table-list)))
        (setq Ic-Option (nth 1 (nth N Ic-Table-list)))
    ))
    (setq Ic-first t)))

(defun Ic-wink-next ()              ;wink ʼΥɥء
    (interactive)
    (Ic-face-del Ic-IDX)
    (setq Ic-IDX (+ Ic-IDX (1-(window-height))))
    (if(<= Ic-max Ic-IDX)(setq Ic-IDX (1- Ic-max)))
    (setq Ic-refresh nil)
    (Ic-after-cur)  )

(defun Ic-wink-prev ()              ;wink Υɥء
    (interactive)
    (Ic-face-del Ic-IDX)
    (setq Ic-IDX (- Ic-IDX (1-(window-height))))
    (if(< Ic-IDX 0)(setq Ic-IDX 0))
    (setq Ic-refresh nil)
    (Ic-after-cur)
    )

(defun Ic-idx-spec (N)              ;IDX
    (Ic-face-del Ic-IDX)
    (setq Ic-IDX N)
    (if(< Ic-IDX 0)(setq Ic-IDX 0))
    (if(<= Ic-max Ic-IDX)(setq Ic-IDX 0))
    (setq Ic-refresh nil)
    (Ic-after-cur)
    )

(defun Ic-5-up ()                   ;壵źϸ
    (interactive)
    (Ic-face-del Ic-IDX)
    (setq Ic-IDX (- Ic-IDX 5))
    (if(< Ic-IDX 0)(setq Ic-IDX 0))
    (setq Ic-refresh nil)
    (Ic-after-cur)
;    (setq Ic-ae t)
    )
(defun Ic-5-down ()                 ;ź
    (interactive)
    (Ic-face-del Ic-IDX)
    (setq Ic-IDX (+ Ic-IDX 5))
    (if(<= Ic-max Ic-IDX)(setq Ic-IDX (1- Ic-max)))
    (setq Ic-refresh nil)
    (Ic-after-cur)
;    (setq Ic-ae t)
    )
(defun Ic-resplit (to)              ;wink  ʬѤޤ to  '+  '-
    (interactive)
	(if (symbolp (Ic-option 'wink 1))
		(set (Ic-option 'wink 1) (funcall to Ic-wink 1))
		(Ic-optmod Ic-Option 'wink (funcall to Ic-wink 1))
		)
    (if (= 0 Ic-wink)(setq Ic-wink 1))
    )

(defun Ic-resplit-a ()(Ic-resplit '+))
(defun Ic-resplit-b ()(Ic-resplit '-))

(defun Ic-wine-sdown ()
	(Ic-write-wine (setq Ic-refresh nil)(condition-case var (scroll-up 3)(error))))

(defun Ic-wine-sup   ()
	(Ic-write-wine (setq Ic-refresh nil)(condition-case var (scroll-down 3)(error))))

(defun Ic-next-dsp()
	(let ((I 0)) (while (< I Ic-wink) (Ic-wink-next)(setq I (1+ I))))
	)

(defun Ic-prev-dsp()
	(let ((I 0)) (while (< I Ic-wink) (Ic-wink-prev)(setq I (1+ I))))
	)

;-------------------------------------------------------------------------------
;
;    :  ޥư
;
(defun Ic-mouse-1 ()
    (interactive)
    (save-window-excursion(condition-case nil(let ((FIRST last-input-event)(KEY nil))
        (select-window (posn-window (car(cdr FIRST))))
        (goto-char (posn-point (car(cdr FIRST))))
;       (goto-char (let ((POS(posn-point (car(cdr FIRST)))))(if(integer-or-marker-p POS)POS (throw 'BREAK t)))); We can't click bar
        (set-mark (point))
        (setq transient-mark-mode t)
        (track-mouse
            (while (not (equal "mouse-1" (prin1-to-string (event-basic-type KEY))))
                (setq KEY (elt (read-key-sequence nil) 0))
                (let((POS(posn-point (nth 1 KEY))))(cond
                    ((integer-or-marker-p POS)  (goto-char POS))
                    ((eq nil POS)               (scroll-down 3))
                    ((eq 'mode-line POS)        (scroll-up   3))
                    (t(message (prin1-to-string POS)))
                ))))
        (if (eq(posn-window (event-start KEY))(posn-window(event-end KEY)));must same window
            (let ((X (posn-point (event-start KEY)))(Y (posn-point(event-end KEY))))
                (if(and(integer-or-marker-p X)(integer-or-marker-p Y))(copy-region-as-kill X Y))))
        (setq transient-mark-mode nil)
        (setq Ic-refresh 'save)
    )(error nil))))

;ݥȰ֤ιֹ椫顢Ic-lines 򸡺ơź֤
(defun Ic-mouse-2 ()
    (interactive)
    ;MILK ɥä
    (if (or (eq Ic-win-milk (posn-window (event-start last-input-event)))
		(member (posn-window (event-start last-input-event)) Ic-milk-list)
		)
    (catch 'BREAK (let((IDX)(POINT (posn-point (event-start last-input-event))))
        (if (numberp POINT)()(throw 'BREAK nil))    ; ⡼ɥ饤
        (setq IDX (Ic-point-to-idx POINT))
        (if (eq IDX Ic-IDX)(setq unread-command-events '(return))(Ic-idx-spec IDX))
    ))))

(defvar Ic-not-str "[] \t\n/;:{}()\\\\\\[\\\"#$%&'~=|\\*\\+><.,]")

;(point)->Ic-IDX
(defun Ic-point-to-idx (POINT)
    (catch 'FIND
        (let ((I (1- (length Ic-lines))))
            (while (not (< I 0))
                (if (>= (U-point-to-line POINT) (nth I Ic-lines))(throw 'FIND I))
                (setq I (1- I))
                )
            (throw 'FIND 0)
        )))

;-------------------------------------------------------------------------------
;
;    :  Ƽ︡롼
;
(defun Ic-search-f-IDX ()
    (goto-char 1)
    (isearch-forward-regexp)
    (Ic-idx-spec (Ic-point-to-idx (point)))
    )

(defun Ic-search-b-IDX ()
    (goto-char 1)
    (isearch-backward-regexp)
    (Ic-idx-spec (Ic-point-to-idx (point)))
    )

(defvar Ic-search-IDX 0)
(defvar Ic-search-REGEXP 0)

(defun Ic-search-b-STR ()
    (setq Ic-refresh 'save)
    (if (eq 0 Ic-search-IDX)(message "ˤǤʤǤ")(Ic-search-sub Ic-search-REGEXP (1- Ic-search-IDX) t))
    )
(defun Ic-search-r-STR ()
    (setq Ic-refresh 'save)
    (Ic-search-sub Ic-search-REGEXP (1+ Ic-search-IDX) nil)
    )

(defun Ic-search-STR ()
    (setq Ic-search-IDX Ic-IDX)
    (setq Ic-search-REGEXP(read-from-minibuffer "ʸ󸡺 REGEXP :"))
    (message (concat "ɽϿޤ"
        (U-map-to-keystr 'Ic-search-r-STR Ic-mode-map)" "
        (U-map-to-keystr 'Ic-search-b-STR Ic-mode-map)" "
        "ˤäƸǤޤ"))
    )

(defun Ic-search-sub (REGEXP start dire)            ;dire = nil : 0 to 999
    "ʸ򸡺ơιܤ˰ưޤ"
    (catch 'END (let ((POS 0)(STR)(IDX start)(EXEC nil))
    (Ic-idx-spec (setq Ic-search-IDX(catch 'BREAK (while t
        ;ʸμФ
        (setq EXEC (nth 2 (nth IDX (eval Ic-Table))))
        (setq STR (cond
            ((vectorp   EXEC)(U-vector-to-keystr EXEC))
            ((stringp   EXEC)EXEC)
            ((atom      EXEC)(concat
                (prin1-to-string (if (boundp EXEC)(eval EXEC)EXEC))
                " "(if (functionp EXEC)(U-map-to-keystr EXEC global-map))
                ))
            ;ꥹȤѤ˺뤷ɾη̥Хåեľܽ񤭹褦
            ;ܤäȤǤޤ͡
            ((listp     EXEC)   (condition-case nil(if (null (car EXEC))
                                    (eval(cdr EXEC))
                                    (let ((STR (eval EXEC)))(if (stringp STR)STR(prin1-to-string STR))))
                                (error(prin1-to-string EXEC))))
            (t          (prin1-to-string EXEC))))
        ;ʸθ
        (if (setq POS (condition-case nil (string-match REGEXP STR)(error)))(throw 'BREAK IDX)(setq IDX (if dire (1- IDX)(1+ IDX))))
        (if (if dire (< IDX 0)(> IDX Ic-max))(progn(message "ʸ̵褦")(throw 'END t)))
        ))))
    ;ưޤ
    (Ic-write-wine (goto-char POS)(recenter 0))
    (message (concat REGEXP " ޤ"))
    )))

;-------------------------------------------------------------------------------
;
; ưIc-table Ȱäơ֤ơ֥ͤФ
;
;
;
(defun Ic-idx (elem &optional idx table f rep)        ; ܥꥹȻ(Ic-IDX 鸡 tree-mode λˤǤ)
	" ֤ (\"ɽ\" ꥿ \"ʸ\" ...) ֤

	ELEM	: ֹ
	IDX		: ֹ def : Ic-IDX
	TABLE	: ơ֥ def : Ic-Table ܥϤ
	F		: ֤ưե饰()
	REP		: ֤

		nil	: 
		t	: ֤	table[idx][elem]=rep
		ins	: 
		del	: 
		push: ץå
		pop	: ݥå
"
	(if idx		nil (setq idx Ic-IDX))
	(if table	nil (setq table Ic-Table))

	(if (or (condition-case nil (Ic-option 'tree 0)(error nil))f)
	;̥Ρɤõ
	(cond
	; ܤǤ֤
	((eq f nil)	(let ((A (Ic-xdi idx (eval table) 0 (list 0) 0)))(if (numberp (car-safe A))nil(if elem (nth elem A)A))))
	; Ǥѹ
	((eq f t)	(let ((A (Ic-xdi idx (eval table) 0 (list 0) 0)))(if (numberp (car-safe A))nil (U-modq A elem rep))))
	; ܤ(ܤֹ֤)
	((eq f 'ins)(if (eval table) (let* (
					(A (Ic-xdi idx (eval table) 0 (list 0) 0 (list 0)))
					(B (if (vectorp A)(elt A 0)(list 0)))
					(I (nth (1- (length B)) B))
					(C (progn (U-del B -1)(if B (nth 3 (Ic-table nil B (eval table)))(eval table))))
					(D (if (symbolp C)(eval C)C))
					)
					(setcdr (nthcdr I D) (cons rep (nthcdr (1+ I) D)))
				(1+ I))
				(set table (list rep))
				))
	; ܤ
	((eq f 'del)	(if (> 2 (length (eval table)))(set table nil)(let* (
						(A (Ic-xdi idx (eval table) 0 (list 0) 0 (list 0)))
						(B (elt A 0))
						(I (nth (1- (length B)) B))
						(C (progn (U-del B -1)(if B (nth 3 (Ic-table nil B (eval table)))(eval table))))
						(D (if (symbolp C)(eval C)C))
						)
						(U-del D I)
				)))
	; ܤ(&push)
	((equal f 'push)(if (eval table)(let (
						(A (Ic-xdi idx (eval table) 0 (list 0) 0))
						)
					(setq Ic-PP (append Ic-PP (list A)))
					(Ic-idx nil idx table 'del)
				)))

	; ܤ(pop)
	((equal f 'pop) (if Ic-PP(progn (if (eval table)
						(Ic-idx elem idx table 'ins (nth (1- (length Ic-PP)) Ic-PP))
						(set table (list (nth (1- (length Ic-PP)) Ic-PP))))
						(U-del Ic-PP -1)
					)))
		)
	;̥Ρɤõ̵(Ic-xdiϺƵ٥뤬ˤʤ뤫ʡ)
	(Ic-table elem idx (eval table))
	))

;(setq Ic-PP nil)
;(setq Um4-nil-table nil)

(defun Ic-menu-pop      ()"ܤУϣ"(Ic-idx nil nil nil 'pop))
(defun Ic-menu-push     ()"ܤУգӣ"(Ic-idx nil nil nil 'push))
(defun Ic-menu-insert   ()"ܤ"(Ic-idx nil nil nil 'ins (list nil)))
(defun Ic-menu-delete   ()"ܤ"(Ic-idx nil nil nil 'del))
(defun Ic-menu-title	()"ܤΥȥ"(Ic-idx 0	nil nil t (read-from-minibuffer "ɽ : " (Ic-idx 0))))
(defun Ic-menu-short	()"硼ȥåʸϿ"(let (CH)(message "硼ȥåʸ : ")(setq CH (read-event))(Ic-idx 8 nil nil t CH)))
(defun Ic-menu-short-del()"硼ȥåʸκ"(Ic-idx 8 nil nil t nil))
(defun Ic-toggle-tree	()"ڹ¤Υȥ"(Ic-optmod nil 'tree (not (Ic-option 'tree 0))))				; ڹ¤

;-------------------------------------------------------------------------------
;
; ưIc-idx ̥롼
;
; idx	: ź		def = Ic-IDX
; table	: ơ֥	def = (eval Ic-Table)
; n,s,i	: ѿ	ʲ
; p		: '(0) ϤСIc-table  IDX ꥹȤޤ٥֤
;
;			n	s			i		p
; 0		0	(1)			0		(0)
; 1	1	(1 1)		0		(0 0)
; 2	1	(1 2)		1		(0 1)
; 3		0	(2 2)		1		(1)
; 4	1	(2 3)		0		(1 0)
; 5	1	(2 4)		1		(1 1)
;   6	2	(2 4 1)		0		(1 1 0)
;   7	2	(2 4 2)		1		(1 1 1)
;   8	2	(2 4 3)		2		(1 1 2)
; 9		0	(3 4 3)		2		(2)
;
;
; table = (nil)  p ꤷƤ٥ʤԹͭꡣ
;
;

(defun Ic-xdi (idx table n s i &optional p)
	(U-mod s n (let ((K (nth n s)))(1+ (if K K 0))))	;ΥΡɤбͤ1
	(let* (
		(L (nth i table))
		(l3 (nth 3 L))(L3 (if (symbolp l3)(eval l3)l3))
		)(cond
		((not L) (U-mod s n (let ((K (nth n s)))(1- (if K K 0)))) s)
		((eq (1- (apply '+ s)) idx) (if p (vector p) L))
		((and (Ic-option 'tree)L3 (nth 10 L))
			(let ((R (Ic-xdi idx L3 (1+ n) s 0 (if p (append p (list 0))))))(if							; ̥Ρɤõ
					(numberp (car-safe R))(progn (if p (U-add-end p))(Ic-xdi idx table n R (1+ i) p))R)	; ʤм
			))
		(t (if p (U-add-end p))(Ic-xdi idx table n s (1+ i) p))											; 
	)))


;-------------------------------------------------------------------------------
;
; ưIc-idx ȰäơΡɤꤷƥơ֥ͤФ
;
(defun Ic-table (ELEM &optional IDX TABLE)        ; ܥꥹȻ
"	ELEM	: (([0]string [1]return [2]expression [3]next1 [4]next2 [5]user [6]emphasize [7]rest [8]key-select [9]local-keymap [10]open-treep)...)
	IDX		: default = Ic-IDX ̥ΡɤꤹȤˤϡ(0 1 2 3) ʤɤȤ롣
	TABLE	: default = (eval Ic-Table)
"
	(if (listp IDX)nil(setq IDX (list (if IDX IDX Ic-IDX))))
	(if (consp (cdr IDX))
		(Ic-table ELEM (cdr IDX) (let ((R (nth 3 (nth (car IDX) (if TABLE TABLE (eval Ic-Table))))))(if (symbolp R)(eval R)R)))
		(if ELEM 
			(nth ELEM (nth (if IDX (car IDX) Ic-IDX) (if TABLE TABLE (eval Ic-Table))))
			(nth (car IDX) (if TABLE TABLE (eval Ic-Table))))
		)
    )

;-------------------------------------------------------------------------------
;
; ư : ץѹ
;
;	(Ic-optmod Ic-Option top etc...)
;
;	(top c1 c2 c3 ... )
;
(defun Ic-optmod (list idx &rest to)  ;ץäƿϿ(ϡܥ)
	(if list nil (setq list Ic-Option))
    (set list (U-del3 idx (eval list)))						;list  car  idx ǤꥹȤƺơto ֤
    (if (equal '(nil) to)nil(set list (append (list (if to (append (list idx) to) (list idx))) (eval list))))
    )

; ץꥹȻ
;
;	(Ic-option 'title num A) Τ褦˼¹Ԥ롣
;
;	ץΤnum ܤǤ֤A  t ʤСnum ʹߤ֤
;
(defmacro Ic-option (key &optional num list A)
    `(let ((L (assoc ,key (if (null ,list)(eval Ic-Option),list))))
    (if ,A (nthcdr (if ,num ,num 0) L)(nth (if ,num ,num 0) L)))
    )

;-------------------------------------------------------------------------------
;
;    :  ΡɤŪ߲ʥΡϿΤǡˤΤܤޤ
;
(defun Ic-specify-node (NEXT-LST NEXT-OPT)
    (setq Ic-Table-list (append Ic-Table-list (list (list NEXT-LST NEXT-OPT Ic-IDX)))
     Ic-Option	NEXT-OPT
     Ic-Table	NEXT-LST
     Ic-IDX		0
     Ic-first	t
	)
	(setq
;	 Ic-keymap (mapcar (lambda (k)(while (and (not (null k))(not (keymapp (setq k (condition-case nil (eval k)(error)))))))k)(nthcdr 1 (assoc 'keymap (eval Ic-Option))))
;	 Ic-before-exec    (Ic-option 'before-exec 1 nil t)
     Ic-after-exec     (Ic-option 'after-exec 1 nil t)		; 򤷤ʤȡ Ic-specify-node θΥΡɤIc-after-exec¹ԤƤޤᡣUfm  option  after-exec ˱ƶ롣
;     Ic-short-cut (let ((CUT (Ic-option 'short-cut 1 nil t)))(if CUT CUT (Ic-option 'short-cut 0)))
;     Ic-short-disp (Ic-option 'short-disp 0)
    ))

;-------------------------------------------------------------------------------
;
;    :  ƵԽΥᥤ롼
;
;	ƵԽ򤷤ơ(eval do-last) η̤֤
;	do-first ϡƵԽ˼¹Ԥʸʸꤹ롣
;	do-ing	ϡƵԽˤʸ eval ¹ԤΤߡ
;


(defvar Ic-redit-map (U-no-menubar-keymap))
(define-key Ic-redit-map Ic-recursive-key	'exit-recursive-edit				)
(define-key Ic-redit-map Ic-recursive-key2	'Ic-redit-kill						)
(define-key Ic-redit-map [menu-bar Ic-quit] '("Cancel"	. Ic-redit-kill)		)
(define-key Ic-redit-map [menu-bar Ic-save] '("Except"	. exit-recursive-edit)	)

(defun  Ic-redit (&optional do-last do-first do-ing)
    (let (
        (history    (current-window-configuration))
        (Cancel		nil)                ; 󥻥ե饰
        )
    (unwind-protect(let(
        (Ic-save-milk   nil)    ; milk Хåե
        (Ic-save-wine   nil)    ; wine Хåե
        )
	    (select-window Ic-win-wine)
        (save-excursion
            (if (get-buffer Ic-name-wine)(set-buffer Ic-name-wine)(rename-buffer (setq Ic-save-wine (generate-new-buffer-name "Ic-wine"))))
            (if (get-buffer Ic-name-milk)(set-buffer Ic-name-milk)(rename-buffer (setq Ic-save-milk (generate-new-buffer-name "Ic-milk"))))
            )
		;ǽˤ
        (switch-to-buffer Ic-name-wine)           ; wine  Ic-name-wine ɽƤȤϸ¤ʤΤǤ
		(setq buffer-undo-list nil)		;undoХåեǥեȤΥХåե̾ǤϺʤ
		(use-local-map Ic-redit-map)	;˥塼СȤ
        (eval do-first)
        (run-hooks 'Ic-before-rec-hook)
		;ƵԽˤϤ롣
        (let (Ic-rec-flg)	;Ic-rec-flg Ƥ֤ϡmilk  ХåեƤ Ic κƵƤӽФ롣̤
			(if do-ing (eval do-ing)(recursive-edit))
            )
		;Ķ򸵤᤹
        (save-excursion
            (if Ic-save-wine (progn (set-buffer Ic-save-wine)(rename-buffer Ic-name-wine)))
            (if Ic-save-milk (progn (set-buffer Ic-save-milk)(rename-buffer Ic-name-milk)))
            ))
		;Ķ򸵤᤹
		(set-window-configuration history)
		)
	;֤ͤη׻
    (if Cancel (throw 'Ic-NEXT t));Ic Υᥤ롼פª
    (let ((OB (current-buffer)))(unwind-protect(progn
		(switch-to-buffer   Ic-name-wine)
		(use-local-map nil)
		(if do-last (eval do-last)(buffer-string))
		)
		(switch-to-buffer OB)
		))
	))

(defun Ic-redit-kill ()
	(interactive)
	(message "Խޤ")
	(setq Cancel t)
	(exit-recursive-edit)
	)


;-------------------------------------------------------------------------------
;
;    :  ƵԽ򤷤ƣӼɤ߼ä֤
;
;       ELE     ơ֥ǤѹȤΰ(줬ʤСñˣӼ֤Τ)
;       LIST    ơ֥ǤѹȤ Ӽ RET ˥ХɤơΥꥹȤ¹Ԥ롣
;       INIT    ԽȤνʸ(nil ǡELE ꤵƤȤˤϡƤɽ)

(defun Ic-table-s(&optional ELE LIST INIT)
    (Ic-redit
        ;֤
        '(let ((RET nil))
            (goto-char (point-min))(insert "(quote ")
            (goto-char (point-max))(insert ")")
            (condition-case nil (setq RET (eval-last-sexp 1))(error nil))
            (if (numberp ELE) (if LIST
                    (Ic-idx ELE nil nil t (eval LIST))  ;LIST is like this. (` (prin1 (,@ RET)))
                    (Ic-idx ELE nil nil t RET)))
            RET)
        ;ǽˤư
        (cond
            ((stringp INIT) '(progn (erase-buffer)(insert INIT)(goto-char (point-min))))
            ((numberp ELE) '(progn (erase-buffer)(insert (prin1-to-string (Ic-idx ELE)))(goto-char (point-min))))
    )))

;-------------------------------------------------------------------------------
;
;    :  ʸ֤
;
;	ˡ(Ic-idx n) Խ٤˻Ѥ롣
;
;	INIT	 ʸꤹ롣n ꤷƤɤꤷʤСELE ιܤ̵
;	ELE		 ԽäˡưŪ n ǤѹƤ롣
;	di-ing	 ƵԽǤϤʤ¹Ԥʸ񤯡
;

(defun Ic-table-str (&optional INIT ELE do-ing)
    (Ic-redit
        ;֤
        (if (numberp ELE)
            '(Ic-idx ELE nil nil t (buffer-substring (point-min) (point-max)))
            '(buffer-substring (point-min) (point-max)))
        ;ǽˤư
        (cond
            ((stringp INIT) '(progn (erase-buffer)(insert INIT)(goto-char (point-min))))
            ((numberp INIT) '(let ((STR(Ic-idx INIT))) (erase-buffer)(if (stringp STR)(insert STR))(goto-char (point-min))))
            ((numberp ELE) '(let ((STR(Ic-idx ELE))) (erase-buffer)(if (stringp STR)(insert STR))(goto-char (point-min))))
    )do-ing))

;-------------------------------------------------------------------------------
;
;    :  ơ֥ѿΥ֤򤹤
;
;	N ܤΥȥƵƳǼޤ
;	Opt ̵ǥ֤ OTHERS Ʊե¸٤ܥ롣
;	ƤӽФȤˤϡȤ˺줺ˡ
;
;	㡧(Ic-table-save \"~/.emacs.save\" 'Um4-Table 3 4 'Um4-mod 'Um4-ded)

(defun Ic-table-save (FILENAME SYMBOL &optional N Opt &rest OTHERS)
    (let ((STACK nil))
        (if N (progn
            (Ic-table-save-sub (eval SYMBOL) N Opt)
            (setq STACK (mapcar (function (lambda (A) (list 'quote A))) STACK))
            ))
        (eval (`(U-save-symbol (, FILENAME) SYMBOL (,@ STACK) (,@ (mapcar (function (lambda (A) (list 'quote A))) OTHERS)))))
        (message "Save Ic table and option.")(ding)(sit-for 0.2)(ding)
    ))

;-------------------------------------------------------------------------------
;
;    :  ơ֥ΥեؤΥ
;
;   LIST  ǤNǤܥ륢ȥʤSTACKѤǹˤͤǺƵ롣
;   Opt ϡ̵˥֤륷ܥ롣
;
(defun Ic-table-save-sub (LIST N &optional Opt)
    (let ((I 0)(LEN (length LIST)))(while (< I LEN)(let ((TMP (nth N (nth I LIST))))
        (if (and (not (null TMP))(symbolp TMP)) ; find symbl -> push and recursive.
            (progn(setq STACK (append STACK (list TMP)))(Ic-table-save-sub (eval TMP) N)))
        (if Opt (setq STACK (append STACK (list (nth Opt (nth I LIST))))))
    (setq I (1+ I)))))
    )

;-------------------------------------------------------------------------------
;
;    :  ɥĶ򥻡֤
;
(defmacro   Ic-keep-windows (&rest EVAL)(`(
    (set-window-configuration Ic-history)
    (,@ EVAL)
    (setq Ic-keep-windows (current-window-configuration)))
    ))

;-------------------------------------------------------------------------------
;
;    :  Хåե˽񤭹
;
;   㡧(Ic-write-wine (insert "ī") (insert "ͼ"))
;
(defmacro Ic-write-wine (&rest list)(`
    (if Ic-no-wine nil
        (select-window (if (window-live-p Ic-win-wine)Ic-win-wine(get-buffer-window Ic-name-wine)))
        (,@ list)
        (select-window (if (window-live-p Ic-win-milk)Ic-win-milk(get-buffer-window Ic-name-milk)))
    )))

;(defun Ic-write-wine (&rest list)		;ؿС
;    (if (and (not Ic-no-wine)(get-buffer-window Ic-name-wine))(progn
;        (select-window (if (window-live-p Ic-win-wine)Ic-win-wine(get-buffer-window Ic-name-wine)))
;        (eval (cons 'progn list))
;        (select-window (if (window-live-p Ic-win-milk)Ic-win-milk(get-buffer-window Ic-name-milk)))
;    )(message "Ic error : wine ɥޤ")))

;-------------------------------------------------------------------------------
;
;    :  ΡɰʲƤФ exp ¹Ԥ
;
;	Ǥäˤϡ
;
;    (throw 'Ic-NEXT Ic-IDX)
;
;	¹Ԥɤ
;
(defun Ic-all-nodes (exp &optional N)
	(setq N (if N N 0))
	(let ((Ic-IDX 0))(while (< Ic-IDX Ic-max)
		(eval exp)
		(if (Ic-next-node)(Ic-all-nodes exp (1+ N)))
		(setq Ic-IDX (1+ Ic-IDX))
	)(if (eq 0 N)nil(Ic-prev-node))))


(provide 'Ic)

;;;Ic.el ends here
